unit xUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,ComObj,SHDocVw_TLB ,MSHTML_TLB, StdCtrls,shellapi, OleCtrls,
  SHDocVw,IniFiles, ExtCtrls;



type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure ExectuePost;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FInitialized: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FIniFileName: string;
  sFirstWebAddress : string;
  sUserId : string;
  sPassWord : string;
  sSubmitByTagName : string;
  sSubmitByFormName: string;
  sSubmitByJava : string;
  sSuccessFulTitle : string;
  sLogonWebAddress : string;
  sSystemTimeOut  : string;
  userid_sl, passwrd_sl, SubmitN_sl ,succTitle_sl: Tstringlist;
  nd,MyDir : string;
  IsTargetWeb : boolean;

implementation

{$R *.dfm}

const
  SectionMain = 'AutoPost';
  KeyFirstWebAddress ='FirstWebAddress';
  KeyUserId ='UserId';
  KeyPassWord ='PassWord';
  KeySubmitByTagName ='SubmitByTagName';
  KeySubmitByFormName ='SubmitByFormName';
  KeySubmitByJava ='SubmitByJava';
  KeySuccessFulTitle ='SuccessFulTitle';
  KeyLogonWebAddress ='LogonWebAddress';
  KeySystemTimeOut ='SystemTimeOut';

function Load_inifile(FIniFileName: string): boolean;
var
  IniFile: TIniFile;
begin
  result := false;
  if not form1.FInitialized then begin
    form1.FInitialized := TRUE;
    IniFile := TIniFile.Create(FIniFileName);
    sFirstWebAddress := IniFile.ReadString(SectionMain, KeyFirstWebAddress, '');
    sUserId := IniFile.ReadString(SectionMain, KeyUserId, '');
    sPassWord := IniFile.ReadString(SectionMain, KeyPassWord, '');
    sSubmitByTagName := IniFile.ReadString(SectionMain, KeySubmitByTagName, '');
    sSubmitByFormName := IniFile.ReadString(SectionMain, KeySubmitByFormName, '');
    sSubmitByJava := IniFile.ReadString(SectionMain, KeySubmitByJava, '');
    sLogonWebAddress := IniFile.ReadString(SectionMain, KeyLogonWebAddress, '');
    sSuccessFulTitle := IniFile.ReadString(SectionMain, KeySuccessFulTitle, '');
    sSystemTimeOut := IniFile.ReadString(SectionMain, KeySystemTimeOut, '60');
    IniFile.Free;
    result := true;
  end; // IF NOT
end;


procedure WaitForComplate(WB1 :IWebbrowser2);
begin
  while WB1.ReadyState <> READYSTATE_COMPLETE do
      Application.ProcessMessages;
end;

function WaitForTitle(vDocument : Variant;Substr1:string;TimeOutSec:integer):integer;
var
   intCount : integer;
begin
   // wait for time out
  Result := 0;  // Set to Succful false
  intCount := 0;  // Set to Zero
  while Result = 0 do begin
        inc(intCount);
        sleep(1000);
        if pos(SubStr1,vDocument.Title)>0 then begin
           Result := 1;
           break;
        end;
        if intcount = TimeOutSec then begin
           Result := 2;
           break;
        end;
        Application.ProcessMessages;
  end; // while
end;

function ExecuteScript(doc: IHTMLDocument2; script: string; language: string): Boolean;
var
  win: IHTMLWindow2;
  Olelanguage: Olevariant;
begin
  if doc <> nil then
  begin
    try
      win := doc.parentWindow;
      if win <> nil then
      begin
        try
          Olelanguage := language;
          win.ExecScript(script, Olelanguage);
        finally
          win := nil;
        end;
      end;
    finally
      doc := nil;
    end;
  end;
  result := true;
end;

procedure TForm1.ExectuePost;
var
  ShellWindow: IShellWindows;
  WB: IWebbrowser2;
  spDisp: IDispatch;
  IDoc1: IHTMLDocument2;
  Document: Variant;
  k, m: Integer;
  ovElements: OleVariant;
  i,  lastSucc : Integer;
  vEmpty : oleVariant;
begin


  if sFirstWebAddress <> '' then begin
   ShellExecute(Handle,
      nil,
      pchar('iexplore.exe'),
      pchar(sFirstWebAddress),
      nil,
      SW_MAXIMIZE);
  end
  else begin
      exit;
  end;

  ShellWindow := CoShellWindows.Create;
  // get the running instance of Internet Explorer
  for k := 0 to ShellWindow.Count do
  begin
    spDisp := ShellWindow.Item(k);
    if spDisp = nil then Continue;
    // QueryInterface determines if an interface can be used with an object
    spDisp.QueryInterface(iWebBrowser2, WB);
    if WB <> nil then
    begin
      WaitForComplate(WB);

      WB.Document.QueryInterface(IHTMLDocument2, iDoc1);

      if iDoc1 <> nil then
      begin

            WB := ShellWindow.Item(k) as IWebbrowser2;
            begin
              Document := WB.Document;
              // count forms on document and iterate through its forms
              for m := 0 to Document.forms.Length - 1 do
              begin
                ovElements := Document.forms.Item(m).elements;

                // iterate through elements
                for i := 0 to ovElements.Length - 1 do
                begin

                  // when input fieldname is found, try to fill out
                  try

                    // id
                    if (CompareText(ovElements.item(i).tagName, 'INPUT') = 0) and
                      (CompareText(ovElements.item(i).type, userid_sl[1]) = 0) and
                      (CompareText(ovElements.item(i).name, userid_sl[2]) = 0) then
                    begin
                      ovElements.item(i).Value := userid_sl[0];
                    end;

                    // password
                    if (CompareText(ovElements.item(i).tagName, 'INPUT') = 0) and
                      (CompareText(ovElements.item(i).type, passwrd_sl[1]) = 0) and
                      (CompareText(ovElements.item(i).name, passwrd_sl[2]) = 0) then
                    begin
                      ovElements.item(i).Value := passwrd_sl[0];
                    end;

                    // Submit
                    if sSubmitByTagName<>'' then begin
                        WaitForComplate(WB);
                        // when Submit button is found, try to click
                        if (CompareText(ovElements.item(i).tagName, 'INPUT') = 0) and
                          (CompareText(ovElements.item(i).type, SubmitN_sl[0]) = 0)    and
                          (CompareText(ovElements.item(i).name, SubmitN_sl[1]) = 0)
                        then
                        begin
                          ovElements.item(i).Click;
                        end;
                    end;

                  except
                    break;
                    exit;
                  end;

                end; // for i = 0
              end; // for m := 0
            end; // WB := ShellWindow.Item(k) as IWebbrowser2
      end; // if idoc1 <> nil
    end; // if wb <> nil
  end; // for k := 0 to ShellWindow.Count

  if (sSuccessFulTitle <>'') then begin
      // Play Java Script By Form Name
      if sSubmitByFormName<>'' then begin
        lastsucc := WaitForTitle(Document, SuccTitle_sl[0], strtoint(SuccTitle_sl[1]));
        if lastsucc <> 1 then begin
           // FormName.Submit
           try
             ExecuteScript(iDoc1,sSubmitByFormName+'.submit()',  'JavaScript');
           except
             exit;
           end;
        end;
      end;

      // Play Java Script By OnClick
      if sSubmitByJava<>'' then begin
        lastsucc := WaitForTitle(Document, SuccTitle_sl[0], strtoint(SuccTitle_sl[1]));
        if lastsucc <> 1 then begin
           // Java String
           try
              ExecuteScript(iDoc1, sSubmitByJava,  'JavaScript');
           except
              exit;
           end;
        end;
      end;

      // Wait for Last Logon Complate
      WaitForComplate(WB);

      if sLogonWebAddress <> '' then begin
         lastsucc := WaitForTitle(Document, SuccTitle_sl[0], strtoint(SuccTitle_sl[1]));
         if lastsucc = 1 then begin
            vEmpty := 0;
            try
              wb.Navigate(sLogonWebAddress,vEmpty,vEmpty,vEmpty,vEmpty);
            except
              exit;
            end;
         end;
      end;
  end; // if sSuccessFulTitle <> ''
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  getdir(0, nd);
  MyDir := nd;
  if ParamCount > 0 then begin
    FIniFileName := LowerCase(ParamStr(1));
    if pos('\', FIniFileName) = 0 then begin
      FIniFileName := nd + '\' + FIniFileName;
    end;
    if not fileexists(FIniFileName) then begin
      showmessage('Ѽ: ' + FIniFileName + ' sb!!');
      application.Terminate;
    end;
  end
  else begin
      // ۰ʨo ini W
    FIniFileName := nd + '\' + LowerCase(ExtractFileName(Application.ExeName));
    FIniFileName := Copy(FIniFileName, 1, Length(FIniFileName) - 3) + 'ini';
      //
  end;
  Load_inifile(FIniFileName);
  userid_sl:= Tstringlist.create;
  userid_sl.Text := StringReplace(sUserId,',',#13,[rfReplaceAll]);
  passwrd_sl:= Tstringlist.create;
  passwrd_sl.Text := StringReplace(sPassWord,',',#13,[rfReplaceAll]);
  SubmitN_sl := Tstringlist.create;
  SubmitN_sl.Text := StringReplace(sSubmitByTagName,',',#13,[rfReplaceAll]);
  succTitle_sl := Tstringlist.create;
  succTitle_sl.Text := StringReplace(sSuccessFulTitle,',',#13,[rfReplaceAll]);
  Timer1.Enabled := false;
  Timer1.Interval := 1000*strtoint(sSystemTimeOut);
  Timer1.Enabled := true;
  ExectuePost;
  application.Terminate;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 showmessage('Post Project: ['+ChangeFileExt(Extractfilename(FIniFileName),'')+'] Work Time out');
    application.Terminate;
end;

end.
