unit xUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,ComObj,SHDocVw_TLB ,MSHTML_TLB, StdCtrls,shellapi, OleCtrls,
  SHDocVw, ExtCtrls, ComCtrls, Spin,IniFiles,shlobj,activex;



type
  TForm1 = class(TForm)
    Button2: TButton;
    ListBox1: TListBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Button4: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Shape3: TShape;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    ComboBox2: TComboBox;
    type1: TEdit;
    name1: TEdit;
    value1: TEdit;
    TabSheet2: TTabSheet;
    Shape2: TShape;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ComboBox3: TComboBox;
    type2: TEdit;
    name2: TEdit;
    value2: TEdit;
    TabSheet3: TTabSheet;
    Shape1: TShape;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Type3: TEdit;
    Name3: TEdit;
    value3: TEdit;
    TabSheet4: TTabSheet;
    Shape4: TShape;
    ComboBox1: TComboBox;
    Button1: TButton;
    TabSheet5: TTabSheet;
    Shape5: TShape;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    SpinEdit1: TSpinEdit;
    TabSheet6: TTabSheet;
    Label1: TLabel;
    Edit1: TEdit;
    Button3: TButton;
    Shape6: TShape;
    Label13: TLabel;
    TabSheet7: TTabSheet;
    Edit3: TEdit;
    Shape7: TShape;
    TabSheet8: TTabSheet;
    Shape8: TShape;
    SpinEdit2: TSpinEdit;
    Label14: TLabel;
    Save_Btn: TButton;
    TabSheet9: TTabSheet;
    Shape9: TShape;
    Memo1: TMemo;
    Button5: TButton;
    TabSheet10: TTabSheet;
    Shape10: TShape;
    Edit4: TEdit;
    Button6: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Save_BtnClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
     FInitialized: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ShellWindow: IShellWindows;
  WB: IWebbrowser2;
  spDisp: IDispatch;
  IDoc1: IHTMLDocument2;
  Document: Variant;
  FIniFileName: string;
  sFirstWebAddress : string;
  sUserId : string;
  sPassWord : string;
  sSubmitByTagName : string;
  sSubmitByFormName: string;
  sSubmitByJava : string;
  sSuccessFulTitle : string;
  sTargetFulTitle : string;  
  sLogonWebAddress : string;
  sSystemTimeOut  : string;
  nd,MyDir : string;

implementation

{$R *.dfm}

const

  SectionMain = 'AutoPost';
  KeyFirstWebAddress ='FirstWebAddress';
  KeyUserId ='UserId';
  KeyPassWord ='PassWord';
  KeySubmitByTagName ='SubmitByTagName';
  KeySubmitByFormName ='SubmitByFormName';
  KeySubmitByJava ='SubmitByJava';
  KeyTargetFulTitle ='TargetFulTitle';  
  KeySuccessFulTitle ='SuccessFulTitle';
  KeyLogonWebAddress ='LogonWebAddress';
  KeySystemTimeOut ='SystemTimeOut';





function CreateLink(const lpszPathObj,lpszArgs,lpszDir ,lpszPathLink, lpszDesc: PChar): HRESULT;
const
  IID_IShellLink: TCLSID = (D1:$000214EE; D2:$0; D3:$0; D4:($C0,$0,$0,$0,$0,$0,$0,$46));
  IID_IPersistFile: TGUID = (D1:$0000010B;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
var
    hres: HRESULT;
    psl: IShellLink;
    ppf: IPersistFile;
    wsz: array[0..MAX_PATH] of WideChar;
begin
    hres := CoCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER,
        IID_IShellLink, psl);
    if (SUCCEEDED(hres)) then begin
        psl.SetPath(lpszPathObj);
        psl.SetArguments(lpszArgs);
        psl.SetWorkingDirectory(lpszDir);
        psl.SetDescription(lpszDesc);
        hres := psl.QueryInterface(IID_IPersistFile,ppf);
        if (SUCCEEDED(hres)) then begin
        MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH);
        hres := ppf.Save(wsz, TRUE);
        ppf := nil;
        end;
        psl := nil;
    end;
    Result := hres;
end;



function Save_inifile(FIniFileName: string): boolean;
var
  IniFile: TIniFile;
begin
  result := false;
  if not form1.FInitialized then begin
    IniFile := TIniFile.Create(FIniFileName);
    IniFile.WriteString(SectionMain, KeyFirstWebAddress, sFirstWebAddress);
    IniFile.WriteString(SectionMain, KeyUserId, sUserId);
    IniFile.WriteString(SectionMain, KeyPassWord, sPassWord);
    IniFile.WriteString(SectionMain, KeySubmitByTagName, sSubmitByTagName);
    IniFile.WriteString(SectionMain, KeySubmitByFormName, sSubmitByFormName);
    IniFile.WriteString(SectionMain, KeySubmitByJava, sSubmitByJava);
    IniFile.WriteString(SectionMain, KeySuccessFulTitle, sSuccessFulTitle);
    IniFile.WriteString(SectionMain, KeyTargetFulTitle, sTargetFulTitle);
    IniFile.WriteString(SectionMain, KeyLogonWebAddress, sLogonWebAddress);
    IniFile.WriteString(SectionMain, KeySystemTimeOut, sSystemTimeOut);
    IniFile.Free;
    result := true;
  end; // IF NOT
end;

function ExecuteScript(doc: IHTMLDocument2; script: string; language: string): Boolean;
var
  win: IHTMLWindow2;
  Olelanguage: Olevariant;
begin
  if doc <> nil then
  begin
    try
      win := doc.parentWindow;
      if win <> nil then
      begin
        try
          Olelanguage := language;
          win.ExecScript(script, Olelanguage);
        finally
          win := nil;
        end;
      end;
    finally
      doc := nil;
    end;
  end;
  result := true;
end;








procedure TForm1.Button1Click(Sender: TObject);
begin

  ShellExecute(Handle,
    nil,
    pchar('iexplore.exe'),
    pchar(ComboBox1.text),
    nil,
    SW_SHOW);
    


end;


procedure TForm1.Button2Click(Sender: TObject);
var
  k, m: Integer;
  ovElements: OleVariant;
  i: Integer;

begin
 listbox1.Clear;


  ShellWindow := CoShellWindows.Create;
  // get the running instance of Internet Explorer
  for k := 0 to ShellWindow.Count do
  begin
    spDisp := ShellWindow.Item(k);
    if spDisp = nil then Continue;

    // QueryInterface determines if an interface can be used with an object
    spDisp.QueryInterface(iWebBrowser2, WB);

    if WB <> nil then
    begin


      //  wb.Busy
      while WB.ReadyState <> READYSTATE_COMPLETE do
            Application.ProcessMessages;


      WB.Document.QueryInterface(IHTMLDocument2, iDoc1);
      if iDoc1 <> nil then
      begin

         //memo2.Text := idoc1.body.innerHTML;
         // memo3.Text := idoc1.body.innerText;
        try
            listbox1.Items.Add('Title='+ iDoc1.title);
            listbox1.Items.Add('Url='+ iDoc1.url);
        except
        end;
        WB := ShellWindow.Item(k) as IWebbrowser2;

        begin
          Document := WB.Document;

          // count forms on document and iterate through its forms
          for m := 0 to Document.forms.Length - 1 do
          begin
            // Get Form Name
            try
               listbox1.items.add('FormName='+Document.forms.item(m).name);
            except
            end;
            ovElements := Document.forms.Item(m).elements;
            // iterate through elements
            for i := 0 to ovElements.Length - 1 do
            begin
                try
                  listbox1.items.Add('TagName='+ovElements.item(i).tagName+',Type='+ovElements.item(i).type+',Name='+ovElements.item(i).name+ ',Value='+ovElements.item(i).Value);
                except
                end;
              // when input fieldname is found, try to fill out
            end; // for i = 0
          end; // for m := 0
        end; // WB := ShellWindow.Item(k) as IWebbrowser2
      end; // if idoc1 <> nil
    end; // if wb <> nil
  end; // for







end;


procedure TForm1.Button3Click(Sender: TObject);
var
  vEmpty : oleVariant;
begin
     vEmpty := 0;

     wb.Navigate(edit1.text,vEmpty,vEmpty,vEmpty,vEmpty);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin

  label13.Caption := 'Page: '+  PageControl1.Pages[PageControl1.ActivePageIndex].Caption;
               
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
        PageControl1.ActivePage := PageControl1.Pages[0];
        label13.Caption :=  'Page: '+PageControl1.Pages[PageControl1.ActivePageIndex].Caption;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
const
  ATypes: array[1..4] of string = ('Title', 'Url', 'FormName', 'TagName');
  BTypes: array[1..3] of string = ('Type', 'Name', 'Value');
var
  Str : string;
  i : integer;
  str_sl, Data_sl : Tstringlist;
begin
  str_sl := Tstringlist.create;
  Data_sl := Tstringlist.create;
  Str :=  ListBox1.items[ListBox1.ItemIndex];
  for i := 1 to 4 do begin
      if pos(atypes[i],Str) > 0 then begin
         break;
      end;
  end;
  case i of
  1:
    begin
        //showmessage('title');
        str_sl.Add(copy(STr,pos('=',str)+1,length(str)));
        if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Wait For' then begin
           edit2.Text := str_sl[0];
        end;
        if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Title'
         then begin
           edit4.Text := str_sl[0];
        end;
    end;
  2:
    begin
        //showmessage('url');
        str_sl.Add(copy(STr,pos('=',str)+1,length(str)));
        if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Url' then begin
           ComboBox1.Text := str_sl[0];
        end;
        if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Loged GoTo' then begin
           edit1.Text := str_sl[0];
        end;

    end;
  3:
    begin
       //showmessage('formname');
       str_sl.Add(copy(STr,pos('=',str)+1,length(str)));
       if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='FormName' then begin
           edit3.Text := str_sl[0];
       end;
    end;
  4:
    begin
       //showmessage('tagname');
       str := copy(STr,pos('=',str)+1,length(str));
       Data_sl.text := stringreplace(str,',',#13,[rfReplaceAll]);
       for i := 0 to Data_sl.Count-1 do begin
           // type
           if pos(btypes[1],Data_sl[i]) > 0 then begin
              str_sl.Add(copy(Data_sl[i],pos('=',Data_sl[i])+1,length(Data_sl[i])));
           end;
           // name
           if pos(btypes[2],Data_sl[i]) > 0 then begin
              str_sl.Add(copy(Data_sl[i],pos('=',Data_sl[i])+1,length(Data_sl[i])));
           end;
           // value
           if pos(btypes[3],Data_sl[i]) > 0 then begin
              str_sl.Add(copy(Data_sl[i],pos('=',Data_sl[i])+1,length(Data_sl[i])));
           end;
       end; // for i := 0
       if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='UserId' then begin
           type1.text:=str_sl[0];
           name1.text:=str_sl[1];
           Value1.text:=str_sl[2];
       end;
       if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Password' then begin
           type2.text:=str_sl[0];
           name2.text:=str_sl[1];
           Value2.text:=str_sl[2];
       end;
       if PageControl1.Pages[PageControl1.ActivePageIndex].Caption='Submit' then begin
           type3.text:=str_sl[0];
           name3.text:=str_sl[1];
           Value3.text:=str_sl[2];
       end;

    end;
  end; // case


end;

procedure TForm1.FormCreate(Sender: TObject);

begin
  getdir(0, nd);
  MyDir := nd;
  // ۰ʨo ini W
  FIniFileName := nd + '\' + 'autopost.ini';

end;

procedure TForm1.Save_BtnClick(Sender: TObject);
begin
  sFirstWebAddress := ComboBox1.text;
  sUserId := ComboBox2.text + ',' + Type1.Text + ','+name1.Text;
  sPassWord := ComboBox3.Text +','+ Type2.Text +',' +name2.Text;
  sSubmitByTagName := Type3.Text +','+ name3.Text;
  sSubmitByFormName := Edit3.Text;
  sSubmitByJava := Memo1.Text;
  sTargetFulTitle := Edit4.text ;  
  sSuccessFulTitle := Edit2.text + ','+  inttostr(SpinEdit1.value);
  sLogonWebAddress := Edit1.Text;
  sSystemTimeOut := inttostr(SpinEdit2.Value);
  Save_inifile(FIniFileName);

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Button4.Enabled := false;
   Save_BtnClick(nil);
   ShellExecute(0,'open',Pchar('autopost.exe'),nil,nil,0);
   sleep(1000);
   Button4.Enabled := true;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  sNewName : string;
begin
  sNewName := InputBox('Save As New Ini', 'Please Input Lnk Name', 'autopost');
  if sNewName <> '' then begin
     copyfile(pchar(nd+ '\'+'autopost.ini'),pchar(nd+ '\'+sNewName+'.ini'),false);
     CreateLink (pchar(nd+'\'+'autopost.exe'),pchar(nd+ '\'+sNewName+'.ini'), pchar(nd),pchar(nd+'\'+sNewName+'.lnk'), 'Made By PostEdit');
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
   ComboBox2.Text := value1.Text;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
    ComboBox3.Text := value2.text;
end;

end.
